SystemOrganization addCategory: #'SomethingIt-VDM-Process'!
SystemOrganization addCategory: #'SomethingIt-VDM-Data'!
SystemOrganization addCategory: #'SomethingIt-VDM-Test'!

SIExpressionPrinter subclass: #SIVDMExpressionPrinter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-VDM-Process'!

!SIVDMExpressionPrinter methodsFor: 'defaults' stamp: 'tomooda 11/13/2012 13:54'!
defaultClassMap
	| mappings |
	mappings := Array new writeStream.
	mappings nextPut: #UndefinedObject -> #printUnit:on:.
	mappings nextPut: #SIAlgebraicData -> #printData:on:.
	mappings nextPut: #Set -> #printSet:on:.
	mappings nextPut: #Dictionary -> #printMap:on:.
	mappings nextPut: #Symbol -> #printQuote:on:.
	mappings nextPut: #SIVDMTokenValue -> #printToken:on:.
	mappings nextPutAll: super defaultClassMap.
	^ mappings contents! !

!SIVDMExpressionPrinter methodsFor: 'printing' stamp: 'TO 7/25/2012 15:11'!
printBoolean: anObject on: aStream 
	aStream
		nextPutAll: (anObject == true
				ifTrue: ['true']
				ifFalse: ['false'])! !

!SIVDMExpressionPrinter methodsFor: 'printing' stamp: 'TO 10/18/2012 11:16'!
printData: anSIAlgebraicDataType on: aStream 
	^ self
		printFunc: anSIAlgebraicDataType constructor
		arguments: anSIAlgebraicDataType args
		on: aStream! !

!SIVDMExpressionPrinter methodsFor: 'printing' stamp: 'TO 7/27/2012 17:39'!
printFunc: aString arguments: anArray on: aStream 
	aStream nextPutAll: aString.
	aStream nextPut: $(.
	anArray
		do: [:object | 
			self print: object on: aStream]
		separatedBy: [aStream nextPut: $,].
	aStream nextPut: $)! !

!SIVDMExpressionPrinter methodsFor: 'printing' stamp: 'TO 7/25/2012 17:29'!
printQuote: aString on: aStream 
	aStream nextPut: $<.
	aStream nextPutAll: aString.
	aStream nextPut: $>! !

!SIVDMExpressionPrinter methodsFor: 'printing' stamp: 'TO 9/13/2012 12:41'!
printSet: anObject on: aStream 
	aStream nextPut: ${.
	anObject
		do: [:member | self print: member on: aStream]
		separatedBy: [aStream nextPut: $,].
	aStream nextPut: $}! !

!SIVDMExpressionPrinter methodsFor: 'printing' stamp: 'TO 7/25/2012 15:31'!
printToken: aVDMTokenValue on: aStream 
	aStream nextPutAll: 'mk_token('.
	self print: aVDMTokenValue value on: aStream.
	aStream nextPut: $)! !

!SIVDMExpressionPrinter methodsFor: 'printing' stamp: 'TO 7/25/2012 15:20'!
printTuple: anObject on: aStream 
	aStream nextPutAll: 'mk_('.
	anObject
		do: [:member | self print: member on: aStream]
		separatedBy: [aStream nextPut: $,].
	aStream nextPut: $)! !

!SIVDMExpressionPrinter methodsFor: 'printing' stamp: 'TO 9/20/2012 11:30'!
printUnit: anObject on: aStream 
	aStream nextPutAll: '()'! !

SIExpressionData subclass: #SIVDMConstant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-VDM-Data'!

!SIVDMConstant methodsFor: 'evaluating' stamp: 'tomooda 11/13/2012 11:44'!
value
	^ environment evaluate: expression! !

!SIVDMConstant methodsFor: 'evaluating' stamp: 'tomooda 11/13/2012 11:44'!
value: anObject
	^ self shouldNotImplement! !

!SIVDMConstant methodsFor: 'evaluating' stamp: 'tomooda 11/13/2012 11:45'!
value: arg1 value: arg2
	^ self shouldNotImplement! !

!SIVDMConstant methodsFor: 'evaluating' stamp: 'tomooda 11/13/2012 11:45'!
value: arg1 value: arg2 value: arg3
	^ self shouldNotImplement! !

!SIVDMConstant methodsFor: 'evaluating' stamp: 'tomooda 11/13/2012 11:45'!
valueWithArguments: anArray
	^ self shouldNotImplement! !

SIExpressionData subclass: #SIVDMFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-VDM-Data'!

!SIVDMFunction methodsFor: 'evaluating' stamp: 'TO 9/20/2012 11:32'!
value
	^ environment evaluate: expression, '()'! !

!SIVDMFunction methodsFor: 'evaluating' stamp: 'TO 9/20/2012 11:35'!
value: argument 
	^ self
		valueWithArguments: (Array with: argument)! !

!SIVDMFunction methodsFor: 'evaluating' stamp: 'TO 9/20/2012 11:35'!
value: argument1 value: argument2 
	^ self
		valueWithArguments: (Array with: argument1 with: argument2)! !

!SIVDMFunction methodsFor: 'evaluating' stamp: 'TO 9/20/2012 11:36'!
value: argument1 value: argument2 value: argument3 
	^ self
		valueWithArguments: (Array
				with: argument1
				with: argument2
				with: argument3)! !

!SIVDMFunction methodsFor: 'evaluating' stamp: 'TO 9/20/2012 11:35'!
valueWithArguments: anArray 
	| call |
	call := String new writeStream.
	environment printer
		printFunc: expression
		arguments: anArray
		on: call.
	^ environment evaluate: call contents! !

SIVDMFunction subclass: #SIVDMOperation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-VDM-Data'!

SIExpressionData subclass: #SIVDMVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-VDM-Data'!

!SIVDMVariable methodsFor: 'evaluating' stamp: 'tomooda 11/13/2012 11:52'!
value
	^ environment evaluate: expression! !

!SIVDMVariable methodsFor: 'evaluating' stamp: 'tomooda 11/13/2012 11:52'!
value: anObject
	^ self shouldNotImplement! !

!SIVDMVariable methodsFor: 'evaluating' stamp: 'tomooda 11/13/2012 11:52'!
value: arg1 value: arg2
	^ self shouldNotImplement! !

!SIVDMVariable methodsFor: 'evaluating' stamp: 'tomooda 11/13/2012 11:52'!
value: arg1 value: arg2 value: arg3
	^ self shouldNotImplement! !

!SIVDMVariable methodsFor: 'evaluating' stamp: 'tomooda 11/13/2012 11:52'!
valueWithArguments: anArray
	^ self shouldNotImplement! !

SIAlgebraicData variableSubclass: #SIVDMRecordValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-VDM-Process'!

!SIVDMRecordValue class methodsFor: 'instance creation' stamp: 'TO 7/25/2012 10:44'!
of: aString withAll: anArray 
	| record |
	record := self new: anArray size.
	record setConstructor: aString.
	1
		to: anArray size
		do: [:index | record
				at: index
				put: (anArray at: index)].
	^ record! !

!SIVDMRecordValue methodsFor: 'private' stamp: 'TO 7/27/2012 10:55'!
first
	^ self at: 1! !

!SIVDMRecordValue methodsFor: 'private' stamp: 'TO 7/27/2012 10:56'!
last
	^ self at: self size! !

!SIVDMRecordValue methodsFor: 'printing' stamp: 'TO 7/25/2012 14:41'!
printOn: aStream 
	aStream nextPutAll: constructor.
	aStream nextPut: $(.
	self size > 0 ifTrue: [(self at: 1)
		printOn: aStream].
	2
		to: self size
		do: [:index | 
			aStream nextPutAll: ', '.
			(self at: index)
				printOn: aStream].
	aStream nextPut: $)! !

!SIVDMRecordValue methodsFor: 'private' stamp: 'TO 7/27/2012 10:55'!
second
	^ self at: 2! !

!SIVDMRecordValue methodsFor: 'printing' stamp: 'TO 7/25/2012 10:44'!
storeOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' of: '.
	constructor storeOn: aStream.
	aStream nextPutAll: ' withAll: {'.
	(self at: 1) storeOn: aStream .
	2 to: self size do: [ :index |
		aStream nextPutAll: ' . '.
		(self at: index) storeOn: aStream].
	aStream nextPut: $}! !

!SIVDMRecordValue methodsFor: 'private' stamp: 'TO 7/27/2012 10:56'!
third
	^ self at: 3! !

!String methodsFor: '*SomethingIt-VDM-converting' stamp: 'tomooda 11/13/2012 11:53'!
asVDMConstantIn: anSIVDM
	^SIVDMConstant with: self in: anSIVDM! !

!String methodsFor: '*SomethingIt-VDM-converting' stamp: 'TO 9/20/2012 10:35'!
asVDMExpressionIn: anSIVDM
	^SIExpressionData with: self in: anSIVDM! !

!String methodsFor: '*SomethingIt-VDM-converting' stamp: 'TO 9/20/2012 11:37'!
asVDMFunctionIn: anSIVDM
	^SIVDMFunction with: self in: anSIVDM! !

!String methodsFor: '*SomethingIt-VDM-converting' stamp: 'TO 9/20/2012 11:37'!
asVDMOperationIn: anSIVDM 
	^ SIVDMOperation with: self in: anSIVDM! !

!String methodsFor: '*SomethingIt-VDM-converting' stamp: 'tomooda 11/13/2012 12:00'!
asVDMVariableIn: anSIVDM
	^SIVDMVariable with: self in: anSIVDM! !

SIExternalInterpreter subclass: #SIVDM
	instanceVariableNames: 'stateVariables generatedSpecification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-VDM-Process'!

!SIVDM class methodsFor: 'examples' stamp: 'tomooda 11/14/2012 09:50'!
exampleClickableGravityByFunction
	"SIVDM exampleClickableGravityByFunction"
	| gravity form morph window colors lock  |
	form := Form extent: 500 @ 500 depth: 32.
	morph := form asMorph.
	window := morph openInWindowLabeled: 'Gravity by VDM functions'.
	colors := {Color red . Color green . Color blue} asOrderedCollection.
	lock := Semaphore forMutualExclusion.
	[| vdm points velocities add |
	vdm := SIVDM specification: '
module Point
exports all
definitions
types
  Point :: x : real
           y : real;
functions
  plus : Point * Point -> Point
  plus(mk_Point(x1,y1), mk_Point(x2,y2)) == mk_Point(x1+x2, y1+y2);

  minus : Point * Point -> Point
  minus(mk_Point(x1,y1), mk_Point(x2,y2)) == mk_Point(x1-x2, y1-y2);

  neg : Point -> Point
  neg(mk_Point(x,y)) == mk_Point(-x, -y);

  scale : real * Point -> Point
  scale(a, mk_Point(x,y)) == mk_Point(a*x, a*y);

  dist2 : Point -> real
  dist2(mk_Point(x,y)) == x * x + y * y;

  dist : Point -> real
  dist(p) == dist2(p) ** 0.5;
end Point

module Gravity
imports from Point
    types
        Point renamed Point;
    functions
        plus renamed plus;
        minus renamed minus;
        neg renamed neg;
        scale renamed scale;
        dist2 renamed dist2;
        dist renamed dist
exports all
definitions
values
  gmn = 50.0;
functions
  total : seq of Point -> Point
  total(ps) == cases ps :
    [] -> mk_Point(0.0,0.0),
    others -> plus(hd ps, total(tl ps))
    end;

  gravity1 : Point * Point -> Point
  gravity1(p1, p2) ==
    let
      v = minus(p2, p1),
      d2 = dist2(v)
    in
      if d2 < 400.0
      then mk_Point(0.0, 0.0)
      else scale(gmn/(d2**1.5), v);

  gravity : seq of Point -> seq of Point
  gravity(ps) == [total([gravity1(ps(i1), ps(i2)) | i2 in set {1,...,len ps}]) | i1 in set {1,...,len ps}];
end Gravity
'.
	vdm printer
		addClassMap: #Point
		to: [:point :vdmStream | 
			vdmStream nextPutAll: 'mk_Point`Point('.
			point x printOn: vdmStream.
			vdmStream nextPut: $,.
			point y printOn: vdmStream.
			vdmStream nextPut: $)].
	vdm parser
		addAlgebraicDataMap: 'mk_Point'
		to: [:constructor :args | args first @ args second].
	gravity := 'Gravity`gravity' asVDMFunctionIn: vdm.
	points := {100.0 @ 250.0. 250.0 @ 250.0. 250.0 @ 350.0} asOrderedCollection.
	velocities := {0.0 @ 0.0. 0.0 @ 0.0. 0.0 @ 0.0} asOrderedCollection.
	add := [:array1 :array2 | 1
				to: array1 size
				do: [:index | array1 at: index put: (array1 at: index)
							+ (array2 at: index)]].
	morph
		on: #click
		send: #value
		to: [lock critical: [points add: ActiveHand position - morph position.
			velocities add: 0 @ 0.
			colors add: Color black]].
	2000
		timesRepeat: [
			| canvas |
			canvas := form getCanvas.
			canvas fillColor: Color white.
			lock critical: [| forces |
			forces := gravity value: points.
			add value: velocities value: forces.
			add value: points value: velocities.
			points
				with: colors
				do: [:point :color | canvas
						fillOval: (point - 4 extent: 8 @ 8)
						color: color]].
			canvas flush.
			morph changed.
			(Delay forMilliseconds: 20) wait].
	morph delete.
	window delete]
		forkAt: Processor userBackgroundPriority! !

!SIVDM class methodsFor: 'examples' stamp: 'tomooda 11/14/2012 13:18'!
exampleFizzbuzz
	"SIVDM exampleFizzbuzz"

	| fizzbuzzSpec count sayFizz sayBuzz sayFizzBuzz sayNumber window font fizzButton buzzButton fizzbuzzButton numberButton |
	fizzbuzzSpec := SIVDM
		specification:
			'
/*
The FizzBuzz game counts numbers up,
saying Fizz when the number is divisible by 3,
Buzz when the number is divisible by 5,
FizzBuzz when the number is divisible by 15,
otherwise the number.
*/
state counter of
  count : int
init
  -- the game starts with "1".
  s == s = mk_counter(1)
end

functions
  -- say fizz when divisible by 3
  fizz : int -> seq of char
  fizz(x) == if x mod 3 = 0 then "fizz" else "";

  -- say buzz when divisible by 5
  buzz : int -> seq of char
  buzz(x) == if x mod 5 = 0 then "buzz" else "";

  -- say fizzbuzz when divisible by 15, otherwise the number.
  fizzbuzz : int -> token
  fizzbuzz(x) == let fb = fizz(x) ^ buzz(x) in if fb = "" then mk_token(x) else mk_token(fb);

operations
  -- A player says "fizz". Answers whether or not it is legitimate call.
  sayFizz : () ==> bool
  sayFizz() == if fizzbuzz(count) = mk_token("fizz") then (count := count + 1; return true) else return false; 
  -- A player says "buzz". Answers whether or not it is legitimate call.
  sayBuzz : () ==> bool
  sayBuzz() == if fizzbuzz(count) = mk_token("buzz") then (count := count + 1; return true) else return false; 
  -- A player says "fizzbuzz". Answers whether or not it is legitimate call.
  sayFizzBuzz : () ==> bool
  sayFizzBuzz() == if fizzbuzz(count) = mk_token("fizzbuzz") then (count := count + 1; return true) else return false; 
  -- A player says a number. Answers whether or not it is legitimate call.
  sayNumber : () ==> bool
  sayNumber() == if fizzbuzz(count) = mk_token(count) then (count := count + 1; return true) else return false; 

'.
	sayFizz := 'sayFizz' asVDMOperationIn: fizzbuzzSpec.
	sayBuzz := 'sayBuzz' asVDMOperationIn: fizzbuzzSpec.
	sayFizzBuzz := 'sayFizzBuzz' asVDMOperationIn: fizzbuzzSpec.
	sayNumber := 'sayNumber' asVDMOperationIn: fizzbuzzSpec.
	count := 'count' asVDMVariableIn: fizzbuzzSpec.
	font := TextStyle default fontOfSize: 36.
	window := Morph new.
	window extent: 150 @ 150.
	window color: Color white.
	window changeTableLayout.
	window listDirection: #topToBottom.
	window vResizing: #shrinkWrap.
	numberButton := SimpleButtonMorph newWithLabel: count value printString.
	numberButton label: numberButton label font: font.
	numberButton
		target: [ 
			sayNumber value
				ifTrue: [ numberButton label: count value printString font: font ]
				ifFalse: [ SINotifier notify: 'WRONG ANSWER!!' ] ].
	numberButton actionSelector: #value.
	numberButton hResizing: #spaceFill.
	window addMorphBack: numberButton.
	fizzButton := SimpleButtonMorph newWithLabel: 'Fizz'.
	fizzButton label: fizzButton label font: font.
	fizzButton
		target: [ 
			sayFizz value
				ifTrue: [ numberButton label: count value printString font: font ]
				ifFalse: [ SINotifier notify: 'WRONG ANSWER!!' ] ].
	fizzButton actionSelector: #value.
	fizzButton hResizing: #spaceFill.
	window addMorphBack: fizzButton.
	buzzButton := SimpleButtonMorph newWithLabel: 'Buzz'.
	buzzButton label: buzzButton label font: font.
	buzzButton
		target: [ 
			sayBuzz value
				ifTrue: [ numberButton label: count value printString font: font ]
				ifFalse: [ SINotifier notify: 'WRONG ANSWER!!' ] ].
	buzzButton actionSelector: #value.
	buzzButton hResizing: #spaceFill.
	window addMorphBack: buzzButton.
	fizzbuzzButton := SimpleButtonMorph newWithLabel: 'FizzBuzz'.
	fizzbuzzButton label: fizzbuzzButton label font: font.
	fizzbuzzButton
		target: [ 
			sayFizzBuzz value
				ifTrue: [ numberButton label: count value printString font: font ]
				ifFalse: [ SINotifier notify: 'WRONG ANSWER!!' ] ].
	fizzbuzzButton actionSelector: #value.
	fizzbuzzButton hResizing: #spaceFill.
	window addMorphBack: fizzbuzzButton.
	window openInWindow.
	^ fizzbuzzSpec! !

!SIVDM class methodsFor: 'examples' stamp: 'tomooda 11/14/2012 09:34'!
exampleGravityByFunction
	"SIVDM exampleGravityByFunction"
	| gravity form morph window colors |
	form := Form extent: 500 @ 500 depth: 32.
	morph := form asMorph.
	window := morph openInWindowLabeled: 'Gravity by VDM functions'.
	colors := (1 to: 3)
				collect: [:i | Color
						h: i * 360.0 / 10
						s: 1.0
						v: 1.0].
	[| vdm points velocities add |
	vdm := SIVDM specification: '
module Point
exports all
definitions
types
  Point :: x : real
           y : real;
functions
  plus : Point * Point -> Point
  plus(mk_Point(x1,y1), mk_Point(x2,y2)) == mk_Point(x1+x2, y1+y2);

  minus : Point * Point -> Point
  minus(mk_Point(x1,y1), mk_Point(x2,y2)) == mk_Point(x1-x2, y1-y2);

  neg : Point -> Point
  neg(mk_Point(x,y)) == mk_Point(-x, -y);

  scale : real * Point -> Point
  scale(a, mk_Point(x,y)) == mk_Point(a*x, a*y);

  dist2 : Point -> real
  dist2(mk_Point(x,y)) == x * x + y * y;

  dist : Point -> real
  dist(p) == dist2(p) ** 0.5;
end Point

module Gravity
imports from Point
    types
        Point renamed Point;
    functions
        plus renamed plus;
        minus renamed minus;
        neg renamed neg;
        scale renamed scale;
        dist2 renamed dist2;
        dist renamed dist
exports all
definitions
values
  gmn = 50.0;
functions
  total : seq of Point -> Point
  total(ps) == cases ps :
    [] -> mk_Point(0.0,0.0),
    others -> plus(hd ps, total(tl ps))
    end;

  gravity1 : Point * Point -> Point
  gravity1(p1, p2) ==
    let
      v = minus(p2, p1),
      d2 = dist2(v)
    in
      if d2 < 400.0
      then mk_Point(0.0, 0.0)
      else scale(gmn/(d2**1.5), v);

  gravity : seq of Point -> seq of Point
  gravity(ps) == [total([gravity1(ps(i1), ps(i2)) | i2 in set {1,...,len ps}]) | i1 in set {1,...,len ps}];
end Gravity
'.
	vdm printer
		addClassMap: #Point
		to: [:point :vdmStream | 
			vdmStream nextPutAll: 'mk_Point`Point('.
			point x printOn: vdmStream.
			vdmStream nextPut: $,.
			point y printOn: vdmStream.
			vdmStream nextPut: $)].
	vdm parser
		addAlgebraicDataMap: 'mk_Point'
		to: [:constructor :args | args first @ args second].
	gravity := 'Gravity`gravity' asVDMFunctionIn: vdm.
	points := {100.0 @ 250.0. 250.0 @ 250.0. 250.0 @ 350.0} asOrderedCollection.
	velocities := {0.0 @ 0.0. 0.0 @ 0.0. 0.0 @ 0.0} asOrderedCollection.
	add := [:array1 :array2 | 1
				to: array1 size
				do: [:index | array1 at: index put: (array1 at: index)
							+ (array2 at: index)]].
	2000
		timesRepeat: [| forces canvas |
			forces := gravity value: points.
			add value: velocities value: forces.
			add value: points value: velocities.
			canvas := form getCanvas.
			canvas fillColor: Color white.
			points
				with: colors
				do: [:point :color | canvas
						fillOval: (point - 4 extent: 8 @ 8)
						color: color].
			canvas flush.
			morph changed.
			(Delay forMilliseconds: 10) wait].
	morph delete.
	window delete]
		forkAt: Processor userBackgroundPriority! !

!SIVDM class methodsFor: 'examples' stamp: 'tomooda 11/14/2012 09:47'!
exampleGravityByOperation
	"SIVDM exampleGravityByOperation"
	| form morph window colors |
	form := Form extent: 500 @ 500 depth: 32.
	morph := form asMorph.
	window := morph openInWindowLabeled: 'Gravity by VDM operations'.
	colors := (1 to: 3)
				collect: [:i | Color
						h: i * 360.0 / 10
						s: 1.0
						v: 1.0].
	[| vdm step positions |
	vdm := SIVDM specification: '
module Point
exports all
definitions
types
  Point :: x : real
           y : real;
functions
  plus : Point * Point -> Point
  plus(mk_Point(x1,y1), mk_Point(x2,y2)) == mk_Point(x1+x2, y1+y2);

  minus : Point * Point -> Point
  minus(mk_Point(x1,y1), mk_Point(x2,y2)) == mk_Point(x1-x2, y1-y2);

  neg : Point -> Point
  neg(mk_Point(x,y)) == mk_Point(-x, -y);

  scale : real * Point -> Point
  scale(a, mk_Point(x,y)) == mk_Point(a*x, a*y);

  dist2 : Point -> real
  dist2(mk_Point(x,y)) == x * x + y * y;

  dist : Point -> real
  dist(p) == dist2(p) ** 0.5;
end Point

module Gravity
exports all
imports from Point
    types
        Point renamed Point;
    functions
        plus renamed plus;
        minus renamed minus;
        neg renamed neg;
        scale renamed scale;
        dist2 renamed dist2;
        dist renamed dist
definitions
values
  gmn = 50.0;
functions
  total : seq of Point -> Point
  total(ps) == cases ps :
    [] -> mk_Point(0.0,0.0),
    others -> plus(hd ps, total(tl ps))
    end;

  gravity1 : Point * Point -> Point
  gravity1(p1, p2) ==
    let
      v = minus(p2, p1),
      d2 = dist2(v)
    in
      if d2 < 400.0
      then mk_Point(0.0, 0.0)
      else scale(gmn/(d2**1.5), v);

  gravity : seq of Point -> seq of Point
  gravity(ps) == [total([gravity1(ps(i1), ps(i2)) | i2 in set {1,...,len ps}]) | i1 in set {1,...,len ps}];
end Gravity

module ParticlesSimulation
exports all
imports
    from Point
        types
            Point renamed Point;
        functions
            plus renamed plus,
    from Gravity
        functions
            gravity renamed gravity

definitions
state Particles of
  positions : seq of Point
  velocities : seq of Point
init
  particles == particles = mk_Particles([], [])
end
operations
  Step : () ==> ()
  Step() == (
    velocities := (let forces = gravity(positions) in [plus(velocities(i), forces(i)) | i in set {1,...,len forces}]);
    positions := [plus(positions(i), velocities(i)) | i in set {1,...,len velocities}]);
  GetPositions : () ==> seq of Point
  GetPositions() == return positions;
  Init : seq of Point * seq of Point ==> ()
  Init(ps, vs) == (positions := ps; velocities := vs);
end ParticlesSimulation
'.
	vdm printer
		addClassMap: #Point
		to: [:point :vdmStream | 
			vdmStream nextPutAll: 'mk_Point`Point('.
			point x printOn: vdmStream.
			vdmStream nextPut: $,.
			point y printOn: vdmStream.
			vdmStream nextPut: $)].
	vdm parser
		addAlgebraicDataMap: 'mk_Point'
		to: [:constructor :args | args first @ args second].
	('ParticlesSimulation`Init' asVDMOperationIn: vdm)
		value: {100.0 @ 250.0. 250.0 @ 250.0. 250.0 @ 350.0} asOrderedCollection
		value: {0.0 @ 0.0. 0.0 @ 0.0. 0.0 @ 0.0} asOrderedCollection.
	step := 'ParticlesSimulation`Step' asVDMOperationIn: vdm.
	positions := 'ParticlesSimulation`GetPositions' asVDMOperationIn: vdm.
	2000
		timesRepeat: [| canvas points |
			step value.
			points := positions value.
			canvas := form getCanvas.
			canvas fillColor: Color white.
			points
				with: colors
				do: [:point :color | canvas
						fillOval: (point - 4 extent: 8 @ 8)
						color: color].
			canvas flush.
			morph changed.
			(Delay forMilliseconds: 10) wait].
	morph delete.
	window delete]
		forkAt: Processor userBackgroundPriority! !

!SIVDM class methodsFor: 'examples' stamp: 'TO 9/20/2012 13:54'!
exampleHelloWorld
	"SIVDM exampleHelloWorld inspect"
	| vdm |
	vdm := SIVDM plain.
	^ [vdm evaluate: '"Hello World"']
		ensure: [vdm close]! !

!SIVDM class methodsFor: 'examples' stamp: 'TO 9/20/2012 13:54'!
exampleMath
	"SIVDM exampleMath inspect"
	| vdm |
	vdm := SIVDM plain.
	^ [vdm evaluate: '1 + 2 * 3']
		ensure: [vdm close]! !

!SIVDM class methodsFor: 'examples' stamp: 'tomooda 11/13/2012 11:55'!
exampleStack
	"SIVDM exampleStack inspect"
	| vdm push pop top stack |
	vdm := SIVDM specification: '
state Stack of
	stack : seq of int
init
	stack == stack = mk_Stack([])
end

operations
	Push : int ==> ()
	Push(c) == stack := [c] ^ stack;
	Pop : () ==> ()
	Pop() == stack := tl stack;
	Top : () ==> int
	Top() == return hd stack;
'.
	push := 'Push' asVDMOperationIn: vdm.
	pop := 'Pop' asVDMOperationIn: vdm.
	top := 'Top' asVDMOperationIn: vdm.
	stack := 'Stack' asVDMVariableIn: vdm.
	#(1 2 3 4 5 6 7 8 9 ) do: push. "performs push(1); push(2); ...; push(9)"
	3 timesRepeat: pop. "takes 9, 8 and 7 away."
	^ {top value. stack value}"will get 6 and mk_Stack([6,5,4,3,2,1])."! !

!SIVDM class methodsFor: 'examples' stamp: 'TO 9/20/2012 14:06'!
exampleTypeError
	"SIVDM exampleTypeError"
	SIVDM plain evaluate: '1+"a"'! !

!SIVDM class methodsFor: 'accessing' stamp: 'TO 10/19/2012 11:32'!
javaPath
	^ '/usr/bin/java'! !

!SIVDM class methodsFor: 'instance creation' stamp: 'tomooda 11/13/2012 13:44'!
load: aPathString 
	^ self plain load: aPathString;
		 yourself! !

!SIVDM class methodsFor: 'instance creation' stamp: 'TomohiroOda 7/20/2012 08:57'!
plain
	^ self new! !

!SIVDM class methodsFor: 'instance creation' stamp: 'tomooda 11/12/2012 13:38'!
specification: aString 
	^ self new
		specification: aString
		ifError: [:msg | 
			SINotifier notify: msg.
			^ nil];
		 yourself! !

!SIVDM class methodsFor: 'accessing' stamp: 'TO 10/19/2012 11:33'!
vdmjPath
	^ 'vdmj-2.0.1.jar'! !

!SIVDM methodsFor: 'private-streaming' stamp: 'tomooda 11/9/2012 14:47'!
backSkipToNonSeparators: aStream 
	[aStream position > 0
		and: [aStream peek isSeparator]]
		whileTrue: [aStream skip: -1]! !

!SIVDM methodsFor: 'private-backdooring' stamp: 'tomooda 11/9/2012 14:35'!
backdoorGetter
	^ self backdoorPrefix , 'getState'! !

!SIVDM methodsFor: 'private-backdooring' stamp: 'tomooda 11/8/2012 15:05'!
backdoorPrefix
	^ '$SomethingIt$'! !

!SIVDM methodsFor: 'private-backdooring' stamp: 'tomooda 11/9/2012 14:36'!
backdoorSetter
	^ self backdoorPrefix , 'setState'! !

!SIVDM methodsFor: 'private-backdooring' stamp: 'tomooda 11/9/2012 15:15'!
createBackdoorModuleForAll: anArrayOfModuleString on: aWriteStream 
	aWriteStream nextPut: Character cr;
		 nextPutAll: '-- the "', self globalModuleName, '" module is automatically generated by SomethingIt. --';
		 nextPut: Character cr.
	aWriteStream nextPutAll: 'module ';
		 nextPutAll: self globalModuleName;
		 nextPut: Character cr.
	aWriteStream nextPutAll: 'imports '.
	anArrayOfModuleString
		do: [:module | aWriteStream nextPutAll: 'from ';
				 nextPutAll: module;
				 space;
				 nextPutAll: 'all']
		separatedBy: [aWriteStream nextPutAll: ', '].
	aWriteStream nextPut: Character cr.
	aWriteStream nextPutAll: 'end ';
		 nextPutAll: self globalModuleName;
		 nextPut: Character cr! !

!SIVDM methodsFor: 'private-backdooring' stamp: 'tomooda 11/14/2012 14:43'!
createBackdoorsFrom: sourceString on: aWriteStream ifError: errorBlock 
	| sourceStream mappings |
	sourceStream := sourceString readStream.
	mappings := Array new writeStream.
	stateVariables := Dictionary new.
	(self
			skip: sourceString readStream
			upToKeyword: 'module'
			ifNone: []) notNil
		ifTrue: [| modules lastPosition |
			modules := Array new writeStream.
			lastPosition := 0.
			self
				scan: (self whiten: sourceString) readStream
				modulesAndStatesAndPositionsDo: [:module :variables :exportsAssoc :currentPosition | 
					modules nextPut: module.
					stateVariables at: module put: variables copy.
					exportsAssoc value
						ifNotNil: [aWriteStream
								nextPutAll: (sourceStream next: exportsAssoc value key - lastPosition).
							sourceStream position: exportsAssoc value value.
							lastPosition := exportsAssoc value value.
							exportsAssoc key
								ifTrue: [aWriteStream nextPut: Character cr]
								ifFalse: [aWriteStream nextPutAll: 'exports '].
							aWriteStream nextPutAll: 'all -- this line is automatically generated by SomethingIt.';
								 nextPut: Character cr].
					aWriteStream
						nextPutAll: (sourceStream next: currentPosition - lastPosition).
					lastPosition := currentPosition.
					aWriteStream
						nextPutAll: (self
								createModuleBackdoorOperationFor: variables
								in: module
								ifError: [:msg | ^ errorBlock value: msg])]
				ifError: [:msg | ^ errorBlock value: msg].
			aWriteStream nextPutAll: sourceStream upToEnd.
			self createBackdoorModuleForAll: modules contents on: aWriteStream]
		ifFalse: [aWriteStream nextPutAll: sourceString.
			self
				scan: (self whiten: sourceString) readStream
				variablesDo: [:variables | 
					stateVariables at: self globalModuleName put: variables copy.
					aWriteStream nextPut: Character cr.
					aWriteStream
						nextPutAll: (self
								createFlatBackdoorOperationFor: variables
								ifError: [:msg | ^ errorBlock value: msg])]
				ifError: [:msg | ^ errorBlock value: msg]].
	^ mappings contents! !

!SIVDM methodsFor: 'private-backdooring' stamp: 'tomooda 11/14/2012 14:57'!
createFlatBackdoorOperationFor: variables ifError: errorBlock 
	| output |
	output := String new writeStream.
	output cr.
	output nextPutAll: '-- the two operations, "' , self backdoorSetter , '" and "' , self backdoorGetter , '", are automatically generated by SomethingIt. --';
		 cr.
	output nextPutAll: 'operations';
		 cr.
	output space; space; space; space.
	output nextPutAll: self backdoorSetter;
		 nextPutAll: ' : '.
	variables isEmpty
		ifTrue: [output nextPutAll: '()']
		ifFalse: [variables
				do: [:var | output nextPut: $?]
				separatedBy: [output nextPut: $*]].
	output nextPutAll: ' ==> ()';
		 cr.
	output space; space; space; space.
	output nextPutAll: self backdoorSetter;
		 nextPutAll: '('.
	variables
		do: [:variable | output nextPutAll: self backdoorPrefix;
				 nextPutAll: variable]
		separatedBy: [output nextPutAll: ', '].
	output nextPutAll: ') == '.
	variables isEmpty
		ifTrue: [output nextPutAll: 'skip']
		ifFalse: [output nextPutAll: 'atomic('.
			variables
				do: [:variable | output nextPutAll: variable;
						 nextPutAll: ' := ';
						 nextPutAll: self backdoorPrefix;
						 nextPutAll: variable]
				separatedBy: [output nextPutAll: ' ; '].
			output nextPutAll: ')'].
	output nextPutAll: ';';
		 cr.
	output space; space; space; space.
	output nextPutAll: self backdoorGetter;
		 nextPutAll: ' : () ==> '.
	variables isEmpty
		ifTrue: [output nextPutAll: '()']
		ifFalse: [variables
				do: [:var | output nextPut: $?]
				separatedBy: [output nextPut: $*]].
	output cr.
	output space; space; space; space.
	output nextPutAll: self backdoorGetter;
		 nextPutAll: '() == '.
	variables isEmpty
		ifTrue: [output nextPutAll: 'skip']
		ifFalse: [output nextPutAll: 'return '.
			variables size > 1
				ifTrue: [output nextPutAll: 'mk_('].
			variables
				do: [:variable | output nextPutAll: variable]
				separatedBy: [output nextPutAll: ','].
			variables size > 1
				ifTrue: [output nextPutAll: ')']].
	output nextPutAll: ';';
		 cr.
	^ output contents! !

!SIVDM methodsFor: 'private-backdooring' stamp: 'tomooda 11/14/2012 14:57'!
createModuleBackdoorOperationFor: variables in: moduleString ifError: errorBlock 
	| output |
	output := String new writeStream.
	output cr.
	output nextPutAll: '-- the two operations, "' , self backdoorSetter , '" and "' , self backdoorGetter , '", are automatically generated and exported by SomethingIt. --';
		 cr.
	output nextPutAll: 'operations';
		 cr.
	output space; space; space; space.
	output nextPutAll: self backdoorSetter;
		 nextPutAll: ' : '.
	variables isEmpty
		ifTrue: [output nextPutAll: '()']
		ifFalse: [variables
				do: [:var | output nextPut: $?]
				separatedBy: [output nextPut: $*]].
	output nextPutAll: ' ==> ()';
		 cr.
	output space; space; space; space.
	output nextPutAll: self backdoorSetter;
		 nextPutAll: '('.
	variables
		do: [:variable | output nextPutAll: self backdoorPrefix;
				 nextPutAll: variable]
		separatedBy: [output nextPutAll: ', '].
	output nextPutAll: ') == '.
	variables isEmpty
		ifTrue: [output nextPutAll: 'skip']
		ifFalse: [output nextPutAll: 'atomic('.
			variables
				do: [:variable | output nextPutAll: variable;
						 nextPutAll: ' := ';
						 nextPutAll: self backdoorPrefix;
						 nextPutAll: variable]
				separatedBy: [output nextPutAll: ' ; '].
			output nextPutAll: ')'].
	output nextPutAll: ';';
		 cr.
	output space; space; space; space.
	output nextPutAll: self backdoorGetter;
		 nextPutAll: ' : () ==> '.
	variables isEmpty
		ifTrue: [output nextPutAll: '()']
		ifFalse: [variables
				do: [:var | output nextPut: $?]
				separatedBy: [output nextPut: $*]].
	output cr.
	output space; space; space; space.
	output nextPutAll: self backdoorGetter;
		 nextPutAll: '() == '.
	variables isEmpty
		ifTrue: [output nextPutAll: 'skip']
		ifFalse: [output nextPutAll: 'return '.
			variables size > 1
				ifTrue: [output nextPutAll: 'mk_('].
			variables
				do: [:var | output nextPutAll: var]
				separatedBy: [output nextPut: $,].
			variables size > 1
				ifTrue: [output nextPutAll: ')']].
	output nextPutAll: ';';
		 cr.
	^ output contents! !

!SIVDM methodsFor: 'communicating' stamp: 'tomooda 11/2/2012 10:19'!
expression: aString ifError: errorReceivingBlock 
	| response |
	response := self trimPrompt: aString.
	^ (response isEmpty
			or: [response first = $=])
		ifTrue: [| expression |
			expression := response readStream next; next; upTo: Character cr.
			(expression notEmpty
					and: [expression last = Character cr])
				ifTrue: [expression := expression copyFrom: 1 to: expression size - 1].
			expression]
		ifFalse: [errorReceivingBlock value: response]! !

!SIVDM methodsFor: 'class access' stamp: 'TomohiroOda 7/24/2012 10:59'!
expressionParserClass 
	^ SIVDMValueParser! !

!SIVDM methodsFor: 'class access' stamp: 'TO 7/27/2012 17:32'!
expressionPrinterClass
	^ SIVDMExpressionPrinter! !

!SIVDM methodsFor: 'private' stamp: 'TO 10/19/2012 11:49'!
forkProcess: desc 
	(OSProcess accessor isExecutable: self javaPath)
			= true
		ifFalse: [| msg |
			msg := String new writeStream.
			msg nextPutAll: 'java not found at ';
				 nextPutAll: self javaPath;
				 nextPutAll: '.';
				 cr;
				 nextPutAll: 'Please specify its fullpath location in SIVDM class>>javaPath.'.
			SINotifier notify: msg contents.
			thisContext terminate].
	(OSProcess accessor
			isReadable: (FileStream fullName: self vdmjPath))
			= true
		ifFalse: [| msg |
			msg := String new writeStream.
			msg nextPutAll: 'The VDMJ interpreter not found at ';
				 nextPutAll: self vdmjPath;
				 nextPutAll: '.';
				 cr;
				 nextPutAll: 'Please specify its fullpath location in SIVDM class>>vdmjPath.';
				 cr;
				 nextPutAll: 'If you don''t have one, please visit http://sourceforge.net/projects/vdmj/ to download it.'.
			SINotifier notify: msg contents.
			thisContext terminate].
	^ UnixProcess
		forkJob: self javaPath
		arguments: {'-jar'. FileStream fullName: self vdmjPath. '-vdmsl'. '-i'. '-w'. '-q'}
		environment: nil
		descriptors: desc! !

!SIVDM methodsFor: 'private-backdooring' stamp: 'tomooda 11/8/2012 15:06'!
globalModuleName
	^ 'DEFAULT'! !

!SIVDM methodsFor: 'initialize-release' stamp: 'tomooda 11/14/2012 13:24'!
initialize
	super initialize.
	stateVariables := Dictionary new.
	generatedSpecification := String new! !

!SIVDM methodsFor: 'accessing' stamp: 'TO 10/19/2012 11:31'!
javaPath
	^ self class javaPath! !

!SIVDM methodsFor: 'processing' stamp: 'TO 10/19/2012 09:58'!
load: aString 
	^ self
		load: aString
		ifError: [:msg | 
			SINotifier notify: msg.
			nil]! !

!SIVDM methodsFor: 'processing' stamp: 'tomooda 11/2/2012 13:32'!
load: aString ifError: errorBlock
	^ self loadAll: (Array with: aString) ifError: errorBlock! !

!SIVDM methodsFor: 'processing' stamp: 'tomooda 11/2/2012 13:32'!
loadAll: anArrayOfString
	^ self
		loadAll: anArrayOfString
		ifError: [ :msg | 
			SINotifier notify: msg.
			nil ]! !

!SIVDM methodsFor: 'processing' stamp: 'tomooda 11/13/2012 10:00'!
loadAll: anArrayOfString ifError: errorBlock 
	| source |
	source := String new writeStream.
	anArrayOfString
		do: [:fileName | SIFileUtils
				readStream: fileName
				do: [:stream | 
					stream
						do: [:char | source nextPut: char].
					source nextPut: Character lf]].
	^ self specification: source contents ifError: errorBlock! !

!SIVDM methodsFor: 'processing' stamp: 'TO 10/17/2012 14:46'!
plainEvaluate: aString limit: anInteger ifError: errorBlock 
	^ super
		plainEvaluate: 'print ' , aString
		limit: anInteger
		ifError: errorBlock! !

!SIVDM methodsFor: 'private-backdooring' stamp: 'tomooda 11/14/2012 13:51'!
privateModuleStateAt: moduleNameString ifError: errorBlock
	self send: 'print ', moduleNameString, '`', self backdoorGetter, '()'.
	^ self expression: self readUpToPrompt ifError: [:msg | errorBlock value: msg ].! !

!SIVDM methodsFor: 'private-backdooring' stamp: 'tomooda 11/14/2012 13:52'!
privateModuleStateAt: moduleNameString put: vdmString ifError: errorBlock
	self send: 'print ', moduleNameString, '`', self backdoorSetter, '(', vdmString, ')'.
	^ self expression: self readUpToPrompt ifError: [:msg | errorBlock value: msg ].! !

!SIVDM methodsFor: 'private-streaming' stamp: 'tomooda 11/7/2012 14:27'!
read: aStream match: aString 
	aString
		do: [:char | 
			aStream atEnd
				ifTrue: [^ false].
			aStream peek = char
				ifFalse: [^ false].
			aStream next].
	^ true! !

!SIVDM methodsFor: 'private-streaming' stamp: 'tomooda 11/7/2012 14:43'!
readNonSeparators: aStream 
	| term |
	term := String new writeStream.
	[aStream atEnd not
		and: [aStream peek isSeparator not]]
		whileTrue: [term nextPut: aStream next].
	^ term contents! !

!SIVDM methodsFor: 'communicating' stamp: 'tomooda 11/14/2012 10:59'!
readUpToPrompt
	| lfStream crStream |
	lfStream := String new writeStream.
	[| chunk |
	chunk := reader upTo: $>.
	lfStream nextPutAll: chunk.
	chunk size <= 1
		or: [ | last |
			last := (chunk at: chunk size - 1).
			last = Character lf or: [last = $]]]] whileFalse.
	crStream := String new writeStream.
	lfStream contents
		linesDo: [:line | 
			crStream nextPutAll: line.
			crStream cr].
		(reader notNil
			and: [reader peek = Character space])
		ifTrue: [reader next].
	^ crStream contents
! !

!SIVDM methodsFor: 'communicating' stamp: 'tomooda 10/31/2012 12:19'!
readUpToPromptLimit: anInteger 
	^ anInteger
		ifNil: [self readUpToPrompt]
		ifNotNil: [| response |
			response := super readUpToPromptLimit: anInteger.
			(reader notNil
					and: [reader peek = Character space])
				ifTrue: [reader next].
			response]! !

!SIVDM methodsFor: 'private-backdooring' stamp: 'tomooda 11/14/2012 14:52'!
scan: aStream modulesAndStatesAndPositionsDo: moduleAndStateAndExportPosEndPosBlock ifError: errorBlock 
	[aStream atEnd not]
		whileTrue: [| module exportsOrDefinitions hasExports exportPosition state |
			self
				skip: aStream
				upToKeyword: 'module'
				ifNone: [^ self].
			self
				skipSeparators: aStream
				ifAtEnd: [^ errorBlock value: 'Expecting an identifier after "module".'].
			module := self readNonSeparators: aStream.
			exportsOrDefinitions := self
						skip: aStream
						upToAnyOfKeywords: #('exports' 'definitions' )
						ifNone: [^ errorBlock value: 'Expected "definitions" in a module.'].
			exportsOrDefinitions = 'exports'
				ifTrue: [| beginExportsPosition |
					hasExports := true.
					self
						skipSeparators: aStream
						ifAtEnd: [^ errorBlock value: 'Unexpected end of file.'].
					beginExportsPosition := aStream position.
					(self readNonSeparators: aStream)
							= 'all'
						ifTrue: [exportPosition := nil]
						ifFalse: [| importsOrDefinitions |
							importsOrDefinitions := self
										skip: aStream
										upToAnyOfKeywords: #('imports' 'definitions' )
										ifNone: [^ errorBlock value: 'Expected "definitions" in a module.'].
							aStream skip: (importsOrDefinitions size + 1) negated.
							self backSkipToNonSeparators: aStream.
							exportPosition := beginExportsPosition -> (aStream position + 1)]]
				ifFalse: [| insertPosition |
					insertPosition := aStream position - exportsOrDefinitions size.
					hasExports := false.
					exportPosition := insertPosition -> insertPosition].
			state := nil.
			[| stateOrEnd |
			stateOrEnd := self
						skip: aStream
						upToAnyOfKeywords: #('state' 'end' )
						ifNone: [^ self].
			stateOrEnd = 'state'
				ifTrue: [self
						skipSeparators: aStream
						ifAtEnd: [^ errorBlock value: 'Expecting an identifier after "state".'].
					state := self readNonSeparators: aStream].
			stateOrEnd = 'end'
				ifTrue: [| position forwardPosition |
					position := aStream position - 3.
					self
						skipSeparators: aStream
						ifAtEnd: [^ errorBlock value: 'Expecting an end of module.'].
					forwardPosition := aStream position.
					(self readNonSeparators: aStream)
							= module
						ifTrue: [state
								ifNil: [moduleAndStateAndExportPosEndPosBlock
										value: module
										value: Array new
										value: hasExports -> exportPosition
										value: position]
								ifNotNil: [| variables |
									variables := Array new writeStream.
									self send: 'default ' , module.
									self readUpToPrompt.
									self send: 'state'.
									self readUpToPrompt
										linesDo: [:line | 
											| pos |
											pos := line indexOf: Character space.
											pos > 1
												ifTrue: [line := line copyFrom: 1 to: (line indexOf: Character space)
																	- 1.
													line = state
														ifFalse: [variables nextPut: line]]].
									variables := variables contents.
									moduleAndStateAndExportPosEndPosBlock
										value: module
										value: variables
										value: hasExports -> exportPosition
										value: position]]
						ifFalse: [aStream position: forwardPosition.
							stateOrEnd := nil]].
			stateOrEnd = 'end'] whileFalse]! !

!SIVDM methodsFor: 'private-backdooring' stamp: 'tomooda 11/14/2012 14:40'!
scan: aStream variablesDo: variablesBlock ifError: errorBlock 
	(self
		skip: aStream
		upToKeyword: 'state'
		ifNone: [])
		ifNil: [variablesBlock value: Array new]
		ifNotNil: [| state variables |
			self
				skipSeparators: aStream
				ifAtEnd: [^ errorBlock value: 'Expecting an identifier after "state".'].
			state := self readNonSeparators: aStream.
			variables := Array new writeStream.
			self send: 'state'.
			self readUpToPrompt
				linesDo: [:line | 
					| pos |
					pos := line indexOf: Character space.
					pos > 1
						ifTrue: [line := line copyFrom: 1 to: (line indexOf: Character space)
											- 1.
							line = state
								ifFalse: [variables nextPut: line]]].
			variablesBlock value: variables contents]! !

!SIVDM methodsFor: 'private-streaming' stamp: 'tomooda 11/7/2012 15:34'!
skip: aStream upToAnyOfKeywords: anArrayOfString ifNone: errorBlock 
	[| position |
	self
		skipSeparators: aStream
		ifAtEnd: [^ errorBlock value].
	anArrayOfString
		do: [:keyword | 
			position := aStream position.
			((self read: aStream match: keyword)
					and: [aStream atEnd
							or: [aStream peek isSeparator]])
				ifTrue: [^ keyword].
			aStream position: position].
	self
		skipNonSeparators: aStream
		ifAtEnd: [^ errorBlock value]] repeat! !

!SIVDM methodsFor: 'private-streaming' stamp: 'tomooda 11/7/2012 15:35'!
skip: aStream upToKeyword: aString ifNone: errorBlock 
	^ self
		skip: aStream
		upToAnyOfKeywords: (Array with: aString)
		ifNone: errorBlock! !

!SIVDM methodsFor: 'private-streaming' stamp: 'tomooda 11/7/2012 14:39'!
skipNonSeparators: aStream ifAtEnd: errorBlock 
	[aStream atEnd not
		and: [aStream peek isSeparator not]]
		whileTrue: [aStream next].
	aStream atEnd
		ifTrue: [^ errorBlock value]! !

!SIVDM methodsFor: 'private-streaming' stamp: 'tomooda 11/7/2012 14:37'!
skipSeparators: aStream ifAtEnd: errorBlock 
	[aStream atEnd not
		and: [aStream peek isSeparator]]
		whileTrue: [aStream next].
	aStream atEnd
		ifTrue: [^ errorBlock value]! !

!SIVDM methodsFor: 'processing' stamp: 'tomooda 11/14/2012 10:29'!
specification: aString ifError: errorBlock 
	self
		critical: [SIFileUtils
				temporaryFile: 'SIVDM-specification:-'
				randomSuffixSize: 8
				suffix: '.vdm'
				do: [:name :stream | 
					stream ascii.
					stream lineEndConvention: #lf.
					stream nextPutAll: aString.
					stream close.
					self startupProcess.
					self send: 'load ' , name.
					self
						expression: self readUpToPrompt
						ifError: [:msg | ^ errorBlock value: msg]].
			SIFileUtils
				temporaryFile: 'SIVDM-specification:-'
				randomSuffixSize: 8
				suffix: '.vdm'
				do: [:name :stream | 
					stream ascii.
					stream lineEndConvention: #lf.
					self
						createBackdoorsFrom: aString
						on: stream
						ifError: [:msg | ^ errorBlock value: msg].
					stream close.
					stream reset.
					generatedSpecification := stream contents.
					stream close.
					self send: 'load ' , name.
					self
						expression: self readUpToPrompt
						ifError: [:msg | ^ errorBlock value: msg].
					self send: 'default ' , self globalModuleName.
					self readUpToPrompt]]! !

!SIVDM methodsFor: 'private' stamp: 'tomooda 10/31/2012 12:25'!
startupProcess
	super startupProcess.
	reader peek = Character space
		ifTrue: [reader next]! !

!SIVDM methodsFor: 'processing' stamp: 'tomooda 11/14/2012 14:59'!
stateAt: moduleNameString 
	self
		critical: [| stateString variableNames |
			variableNames := stateVariables
						at: moduleNameString
						ifAbsent: [SINotifier notify: 'No such module: ' , moduleNameString.
							^ nil].
			stateString := self
						privateModuleStateAt: moduleNameString
						ifError: [:msg | 
							SINotifier notify: msg.
							^ nil].
			^ variableNames isEmpty
				ifTrue: [Array new]
				ifFalse: [variableNames size = 1
						ifTrue: [Array with: variableNames first -> stateString]
						ifFalse: [| state |
							state := Array new writeStream.
							variableNames := variableNames readStream.
							self parser
								scanTuple: stateString readStream
								plainElementsDo: [:value | state nextPut: variableNames next -> value]
								ifError: [:msg | 
									SINotifier notify: msg.
									^ nil].
							state contents]]]! !

!SIVDM methodsFor: 'processing' stamp: 'tomooda 11/14/2012 15:25'!
stateAt: moduleNameString put: anArray 
	self
		critical: [| variableNames stateString |
			variableNames := stateVariables
						at: moduleNameString
						ifAbsent: [SINotifier notify: 'No such module: ' , moduleNameString.
							^ nil].
			stateString := variableNames isEmpty
						ifTrue: [String new]
						ifFalse: [variableNames size = 1
								ifTrue: [(anArray
										detect: [:assoc | assoc key = variableNames first]
										ifNone: [SINotifier notify: 'Missing variable: ' , variableNames first.
											^ nil]) value]
								ifFalse: [| tuple |
									tuple := String new writeStream.
									variableNames
										do: [:name | tuple nextPutAll: (anArray
													detect: [:assoc | assoc key = name]
													ifNone: [SINotifier notify: 'Missing variable: ' , name.
														^ nil]) value]
										separatedBy: [tuple nextPut: $,].
									tuple contents]].
			self
				privateModuleStateAt: moduleNameString
				put: stateString
				ifError: [:msg | 
					SINotifier notify: msg.
					^ nil].
			^ anArray]! !

!SIVDM methodsFor: 'accessing' stamp: 'TO 10/19/2012 11:31'!
vdmjPath
	^ self class vdmjPath! !

!SIVDM methodsFor: 'private-streaming' stamp: 'tomooda 11/13/2012 10:18'!
whiten: aString 
	| output |
	output := String new writeStream.
	self whiten: aString readStream on: output.
	^ output contents! !

!SIVDM methodsFor: 'private-streaming' stamp: 'tomooda 11/9/2012 08:47'!
whiten: aReadStream on: aWriteStream 
	| whitener |
	whitener := #whitenInNormal:on:.
	[aReadStream atEnd]
		whileFalse: [whitener := self
						perform: whitener
						with: aReadStream
						with: aWriteStream]! !

!SIVDM methodsFor: 'private-streaming' stamp: 'tomooda 11/9/2012 09:15'!
whitenInMultilineComment: aReadStream on: aWriteStream 
	| char |
	char := aReadStream next.
	(char = $*
			and: [aReadStream atEnd not
					and: [aReadStream peek = $/]])
		ifTrue: [aReadStream next.
			aWriteStream nextPutAll: '*/'.
			^ #whitenInNormal:on:].
	aWriteStream nextPut: Character space.
	^ #whitenInMultilineComment:on:! !

!SIVDM methodsFor: 'private-streaming' stamp: 'tomooda 11/9/2012 08:29'!
whitenInNormal: aReadStream on: aWriteStream 
	| char |
	char := aReadStream next.
	char = $"
		ifTrue: [aWriteStream nextPut: $".
			^ #whitenInString:on:].
	(char = $-
			and: [aReadStream atEnd not
					and: [aReadStream peek = $-]])
		ifTrue: [aReadStream next.
			aWriteStream nextPutAll: '--'.
			^ #whitenInSinglelineComment:on:].
	(char = $/
			and: [aReadStream atEnd not
					and: [aReadStream peek = $*]])
		ifTrue: [aReadStream next.
			aWriteStream nextPutAll: '/*'.
			^ #whitenInMultilineComment:on:].
	aWriteStream nextPut: char.
	^ #whitenInNormal:on:! !

!SIVDM methodsFor: 'private-streaming' stamp: 'tomooda 11/9/2012 09:15'!
whitenInSinglelineComment: aReadStream on: aWriteStream 
	| char |
	char := aReadStream next.
	char = Character lf
		ifTrue: [aWriteStream nextPut: Character lf.
			^ #whitenInNormal:on:].
	char = Character cr
		ifTrue: [aWriteStream nextPut: Character cr.
			^ #whitenInNormal:on:].
	aWriteStream nextPut: Character space.
	^ #whitenInSinglelineComment:on:! !

!SIVDM methodsFor: 'private-streaming' stamp: 'tomooda 11/9/2012 08:26'!
whitenInString: aReadStream on: aWriteStream 
	| char |
	char := aReadStream next.
	char = $"
		ifTrue: [aWriteStream nextPut: $".
			^ #whitenInNormal:on:].
	(char = $\
			and: [aReadStream atEnd not
					and: [aReadStream peek = $"]])
		ifTrue: [aReadStream next.
			aWriteStream nextPutAll: '  '.
			^ #whitenInString:on:].
	aWriteStream nextPut: Character space.
	^ #whitenInString:on:! !

TestCase subclass: #SIVDMParserPrinterTest
	instanceVariableNames: 'parser printer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-VDM-Test'!

!SIVDMParserPrinterTest methodsFor: 'running' stamp: 'TO 7/25/2012 15:07'!
setUp
	parser := SIVDMValueParser new.
	printer := SIVDMExpressionPrinter new! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'TO 7/25/2012 15:07'!
test: anObject 
	self
		assert: anObject
		equals: (parser
				parse: (printer print: anObject))! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'TO 7/25/2012 15:27'!
testBoolean
	self test: true.
	self test: false! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'TO 7/25/2012 15:07'!
testCharacter
	self test: $a.
	self test: $z! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 14:12'!
testClassMap
	printer
		addClassMap: #Point
		to: [:point :vdmStream | 
			vdmStream nextPutAll: 'mk_Point('.
			point x printOn: vdmStream.
			vdmStream nextPutAll: ','.
			point y printOn: vdmStream.
			vdmStream nextPut: $)].
	parser
		addAlgebraicDataMap: 'mk_Point'
		to: [:constructor :args | args first @ args second].
	self test: 1 @ 2! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'TO 7/25/2012 15:07'!
testInteger
	self
		assert: 441
		equals: (parser parseInteger: '441' readStream).
	self
		assert: -441
		equals: (parser parseInteger: '-441' readStream)! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'TO 7/25/2012 15:07'!
testList
	self test: #(4 4 1 ) asOrderedCollection.
	self test: #(4 ) asOrderedCollection.
	self test: #() asOrderedCollection! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'TO 7/25/2012 15:07'!
testLowerIdentifierChar
	self
		assert: (parser isLowerIdentifierChar: $a).
	self
		assert: (parser isLowerIdentifierChar: $1).
	self
		assert: (parser isLowerIdentifierChar: $_).
	self
		deny: (parser isLowerIdentifierChar: $A).
	self
		deny: (parser isLowerIdentifierChar: $+)! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'TO 7/25/2012 15:08'!
testNat
	self
		assert: 441
		equals: (parser parseNaturalNumber: '441' readStream)! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'TO 7/25/2012 15:08'!
testNumber
	self test: 1.
	self test: -2.
	self test: 3.4.
	self test: -5.6.
	self test: -7.8e-9! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'TO 7/25/2012 17:31'!
testParen
	self assert: (parser parse: '1') equals: (parser parse: '((1))').
	self assert: (parser parse: 'mk_(1)') equals: (parser parse: '(mk_((1)))')! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 14:02'!
testParseErrorMessage
	| message |
	message := 'abc
def
'.
	self
		assert: message
		equals: (parser parseErrorMessage: (message , '> ') readStream)! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'TO 7/25/2012 17:29'!
testQuote
	self test: #Quote.
	self test: #'Like this'! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'TO 7/25/2012 15:29'!
testRecord
	self
		test: (SIVDMRecordValue of: 'mk_Freq' withAll: #(4 4 1 )).
	self
		test: (SIVDMRecordValue of: 'mk_Freq')! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'TO 7/25/2012 15:24'!
testSet
	self test: #(4 4 1 ) asSet.
	self test: #(4 ) asSet.
	self test: #() asSet! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'TO 7/25/2012 15:08'!
testString
	self test: 'Hello world'.
	self test: 'How''ya doing?\nI''m fine, thanks!!'! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'TO 7/25/2012 15:29'!
testToken
	self
		test: (SIVDMTokenValue with: 1).
	self test: (SIVDMTokenValue with: #(4 4 1))! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'TO 7/25/2012 15:08'!
testTuple
	self test: #(4 4 1 ).
	self test: #('Freq' 25 )! !

!SIVDMParserPrinterTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 13:55'!
testUnit
	self test: nil! !

TestCase subclass: #SIVDMRecordValueTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-VDM-Test'!

!SIVDMRecordValueTest methodsFor: 'testing' stamp: 'TO 7/25/2012 17:47'!
testArgs
	self assert: #() equals: (SIVDMRecordValue of: 'fure') args.
	self assert: #(4 4 1 ) equals: (SIVDMRecordValue of: 'freq' withAll: #(4 4 1 )) args! !

!SIVDMRecordValueTest methodsFor: 'testing' stamp: 'TO 7/25/2012 17:47'!
testConstructor
	self assert: 'fure' equals: (SIVDMRecordValue of: 'fure') constructor.
	self assert: 'freq' equals: (SIVDMRecordValue of: 'freq' withAll: #(4 4 1 )) constructor! !

!SIVDMRecordValueTest methodsFor: 'testing' stamp: 'TO 7/25/2012 17:48'!
testEquals
	self assert: (SIVDMRecordValue of: 'freq' withAll: #(4 4 1 ))
			= (SIVDMRecordValue of: 'freq' withAll: #(4 4 1 )).
	self deny: (SIVDMRecordValue of: 'Freq' withAll: #(4 4 1 ))
			= (SIVDMRecordValue of: 'freq' withAll: #(4 4 1 )).
	self deny: (SIVDMRecordValue of: 'freq' withAll: #(4 4 1 ))
			= (SIVDMRecordValue of: 'freq' withAll: #(441 ))! !

!SIVDMRecordValueTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 13:56'!
testFirst
	self assert: 4 equals: (SIVDMRecordValue of: 'freq' withAll: #(4 1 2 6)) first! !

!SIVDMRecordValueTest methodsFor: 'testing' stamp: 'TO 7/25/2012 17:48'!
testHash
	self assert: (SIVDMRecordValue of: 'freq' withAll: #(4 4 1 )) hash equals: (SIVDMRecordValue of: 'freq' withAll: #(4 4 1 )) hash! !

!SIVDMRecordValueTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 13:57'!
testLast
	self assert: 6 equals: (SIVDMRecordValue of: 'freq' withAll: #(4 1 2 6)) last! !

!SIVDMRecordValueTest methodsFor: 'testing' stamp: 'TO 7/25/2012 20:13'!
testPrintString
	self assert: 'fure()' equals: (SIVDMRecordValue of: 'fure') printString.
	self assert: 'freq(4, 4, 1)' equals: (SIVDMRecordValue of: 'freq' withAll: #(4 4 1 )) printString! !

!SIVDMRecordValueTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 13:56'!
testSecond
	self assert: 1 equals: (SIVDMRecordValue of: 'freq' withAll: #(4 1 2 6)) second! !

!SIVDMRecordValueTest methodsFor: 'testing' stamp: 'TO 7/25/2012 17:48'!
testStoreString
	| data |
	data := SIVDMRecordValue of: 'freq' withAll: #(4 4 1 ).
	self
		assert: data
		equals: (Compiler evaluate: data storeString)! !

!SIVDMRecordValueTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 13:56'!
testThird
	self assert: 2 equals: (SIVDMRecordValue of: 'freq' withAll: #(4 1 2 6)) third! !

TestCase subclass: #SIVDMTest
	instanceVariableNames: 'vdm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-VDM-Test'!

!SIVDMTest methodsFor: 'running' stamp: 'TO 7/26/2012 11:28'!
setUp
	vdm := SIVDM new! !

!SIVDMTest methodsFor: 'running' stamp: 'TO 7/26/2012 11:28'!
tearDown
	vdm close.
	vdm := nil! !

!SIVDMTest methodsFor: 'testing' stamp: 'TO 7/26/2012 11:29'!
testArithmetic
	self
		assert: 7
		equals: (vdm evaluate: '1+2*3')! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 12:10'!
testAsVDMConstant
	| hello |
	vdm close.
	vdm := SIVDM specification: 'values
	hello : seq of char = "hello"'.
	hello := 'hello' asVDMConstantIn: vdm.
	self assert: 'hello' equals: hello value.
	vdm close! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 12:06'!
testAsVDMExpression
	| onePlusTwo |
	vdm close.
	vdm := SIVDM plain.
	onePlusTwo := '1 + 2' asVDMExpressionIn: vdm.
	self assert: 3 equals: onePlusTwo value.
	vdm close! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 12:20'!
testAsVDMFunction1
	| f |
	vdm close.
	vdm := SIVDM specification: '
	/* returns the double of the argument */
	functions
		f : int -> int
		f(x) == x * 2'.
	f := 'f' asVDMFunctionIn: vdm.
	self
		assert: 2
		equals: (f value: 1).
	self
		assert: 4
		equals: (f value: 2).
	vdm close! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 12:20'!
testAsVDMFunction2
	| f |
	vdm close.
	vdm := SIVDM specification: '
	/* returns the double of the argument */
	functions
		f : int*int -> int
		f(x,y) == x * y'.
	f := 'f' asVDMFunctionIn: vdm.
	self
		assert: 2
		equals: (f value: 1 value: 2).
	self
		assert: 6
		equals: (f value: 2 value: 3).
	vdm close! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 12:20'!
testAsVDMFunction3
	| f |
	vdm close.
	vdm := SIVDM specification: '
	/* returns the double of the argument */
	functions
		f : int*int*int -> int
		f(x,y,z) == x * y + z'.
	f := 'f' asVDMFunctionIn: vdm.
	self
		assert: 5
		equals: (f
				value: 1
				value: 2
				value: 3).
	vdm close! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 12:20'!
testAsVDMFunction4
	| f |
	vdm close.
	vdm := SIVDM specification: '
	/* returns the double of the argument */
	functions
		f : int*int*int -> int
		f(x,y,z) == x * y + z'.
	f := 'f' asVDMFunctionIn: vdm.
	self
		assert: 5
		equals: (f valueWithArguments: #(1 2 3 )).
	vdm close! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/14/2012 15:04'!
testAsVDMOperation
	| countUp |
	vdm close.
	vdm := SIVDM specification: 'module Counter
definitions
state counter of
	count : int
init
	s == s = mk_counter(1)
end
operations
	countUp : () ==> int -- aka increment
	countUp() == (count := count + 1; return count)
end Counter'.
	countUp := 'Counter`countUp' asVDMOperationIn: vdm.
	self assert: 2 equals: countUp value.
	self assert: 3 equals: countUp value.
	vdm close! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 11:55'!
testAsVDMVariable
	| countUp count |
	vdm close.
	vdm := SIVDM specification: '
state counter of
	count : int
init
	s == s = mk_counter(1)
end
operations
	countUp : () ==> int
	countUp() == (count := count + 1; return count)'.
	countUp := 'countUp' asVDMOperationIn: vdm.
	count := 'count' asVDMVariableIn: vdm.
	self assert: 1 equals: count value.
	countUp value.
	self assert: 2 equals: count value.
	vdm close! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/12/2012 13:56'!
testLoad
	SIFileUtils
		temporaryFile: 'SIVDMTest-testLoad-'
		randomSuffixSize: 8
		suffix: '.vdm'
		do: [:filename :stream | 
			stream nextPutAll: 'functions';
				 lf.
			stream nextPutAll: '  fizzbuzz : int -> token';
				 lf.
			stream nextPutAll: '  fizzbuzz(x) == let fb = fizz(x)^buzz(x) in if fb = "" then mk_token(x) else mk_token(fb);';
				 lf.
			stream lf.
			stream nextPutAll: '  fizz : int -> seq of char';
				 lf.
			stream nextPutAll: '  fizz(x) == if x mod 3 = 0 then "fizz" else "";';
				 lf.
			stream lf.
			stream nextPutAll: '  buzz : int -> seq of char';
				 lf.
			stream nextPutAll: '  buzz(x) == if x mod 5 = 0 then "buzz" else "";';
				 lf.
			stream close.
			vdm close.
			vdm := SIVDM load: filename.
			self assert: 13 equals: (vdm evaluate: 'fizzbuzz(13)') value.
			self assert: 'fizz' equals: (vdm evaluate: 'fizzbuzz(6)') value.
			self assert: 'buzz' equals: (vdm evaluate: 'fizzbuzz(20)') value.
			self assert: 'fizzbuzz' equals: (vdm evaluate: 'fizzbuzz(30)') value.
			vdm close]! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 13:59'!
testLoadAll
	SIFileUtils
		temporaryFile: 'SIVDMTest-testLoad-'
		randomSuffixSize: 8
		suffix: '.vdm'
		do: [:filename :stream | 
			stream nextPutAll: 'functions';
				 lf.
			stream nextPutAll: '  fizz : int -> seq of char';
				 lf.
			stream nextPutAll: '  fizz(x) == if x mod 3 = 0 then "fizz" else "";';
				 lf.
			stream lf.
			stream nextPutAll: '  buzz : int -> seq of char';
				 lf.
			stream nextPutAll: '  buzz(x) == if x mod 5 = 0 then "buzz" else "";';
				 lf.
			stream close.
			SIFileUtils
				temporaryFile: 'SIVDMTest-testLoad-'
				randomSuffixSize: 8
				suffix: '.vdm'
				do: [:filename2 :stream2 | 
					stream2 nextPutAll: 'functions';
						 lf.
					stream2 nextPutAll: '  fizzbuzz : int -> token';
						 lf.
					stream2 nextPutAll: '  fizzbuzz(x) == let fb = fizz(x)^buzz(x) in if fb = "" then mk_token(x) else mk_token(fb);';
						 lf.
					stream2 close.
					vdm
						loadAll: (Array with: filename with: filename2).
					self assert: 13 equals: (vdm evaluate: 'fizzbuzz(13)') value.
					self assert: 'fizz' equals: (vdm evaluate: 'fizzbuzz(6)') value.
					self assert: 'buzz' equals: (vdm evaluate: 'fizzbuzz(20)') value.
					self assert: 'fizzbuzz' equals: (vdm evaluate: 'fizzbuzz(30)') value.
					vdm close]]! !

!SIVDMTest methodsFor: 'testing' stamp: 'TO 7/26/2012 11:29'!
testMultiArithmetic
	self
		assert: 7
		equals: (vdm evaluate: '1+2*3').
	self
		assert: 34
		equals: (vdm evaluate: '4+5*6')! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 14:25'!
testParse
	self
		assert: (OrderedCollection with: 1)
		equals: (vdm parse: '[1]')! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 14:23'!
testPrint
	self
		assert: '[1]'
		equals: (vdm print: (OrderedCollection with: 1))! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/13/2012 11:19'!
testSpecification1
	vdm close.
	vdm := SIVDM specification: '
functions
  fizzbuzz : int -> token
  fizzbuzz(x) == let fb = fizz(x)^buzz(x) in if fb = "" then mk_token(x) else mk_token(fb);
  fizz : int -> seq of char
  fizz(x) == if x mod 3 = 0 then "fizz" else "";
  buzz : int -> seq of char
  buzz(x) == if x mod 5 = 0 then "buzz" else "";'.
	self assert: 13 equals: (vdm evaluate: 'fizzbuzz(13)') value.
	self assert: 'fizz' equals: (vdm evaluate: 'fizzbuzz(6)') value.
	self assert: 'buzz' equals: (vdm evaluate: 'fizzbuzz(20)') value.
	self assert: 'fizzbuzz' equals: (vdm evaluate: 'fizzbuzz(30)') value.
	vdm close! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/14/2012 15:05'!
testSpecification2
	vdm close.
	vdm := SIVDM specification: 'module FizzBuzzGame
definitions
state counter of
	count : int
init
	s == s = mk_counter(1)
end
functions
  fizzbuzz : int -> token
  fizzbuzz(x) == let fb = fizz(x)^buzz(x) in if fb = "" then mk_token(x) else mk_token(fb);
  fizz : int -> seq of char
  fizz(x) == if x mod 3 = 0 then "fizz" else "";
  buzz : int -> seq of char
  buzz(x) == if x mod 5 = 0 then "buzz" else "";
end FizzBuzzGame
'.
	self assert: 13 equals: (vdm evaluate: 'FizzBuzzGame`fizzbuzz(13)') value.
	self assert: 'fizz' equals: (vdm evaluate: 'FizzBuzzGame`fizzbuzz(6)') value.
	self assert: 'buzz' equals: (vdm evaluate: 'FizzBuzzGame`fizzbuzz(20)') value.
	self assert: 'fizzbuzz' equals: (vdm evaluate: 'FizzBuzzGame`fizzbuzz(30)') value.
	vdm close! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/14/2012 15:06'!
testSpecification3
	vdm close.
	vdm := SIVDM specification: 'module FizzBuzzGame
exports operations next:()==>int;
definitions
state counter of
	count : int
init
	s == s = mk_counter(1)
end
operations
	increment : () ==> ()
	increment() == count := count + 1;
	next : () ==> int
	next() == (increment();return count);
end FizzBuzzGame
'.
	self assert: 2 equals: (vdm evaluate: 'FizzBuzzGame`next()').
	self assert: 3 equals: (vdm evaluate: 'FizzBuzzGame`next()').
	vdm close! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/14/2012 15:10'!
testStateAtPutFlat1
	vdm specification: '
	functions
		f : int -> int
		f(x) == x * 2;
		' ifError: [ :msg | self fail].
	self assert: #() equals: (vdm stateAt: 'DEFAULT').
	vdm stateAt: 'DEFAULT' put: Array new.
	self assert: #() equals: (vdm stateAt: 'DEFAULT').! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/14/2012 15:10'!
testStateAtPutFlat2
	vdm
		specification: '
	state foo of
		bar : int
	init
		b == b = mk_foo(1)
	end
	functions
		f : int -> int
		f(x) == x * 2;
		'
		ifError: [:msg | self fail].
	self
		assert: {'bar' -> '1'}
		equals: (vdm stateAt: 'DEFAULT').
	vdm stateAt: 'DEFAULT' put: {'bar' -> '2'}.
	self
		assert: {'bar' -> '2'}
		equals: (vdm stateAt: 'DEFAULT')! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/14/2012 15:38'!
testStateAtPutFlat3
	vdm
		specification: '
	state foo of
		bar : int
		buzz : seq of char
	inv
		mk_foo(bar, buzz) == bar = len buzz
	init
		b == b = mk_foo(1, "2")
	end
	functions
		f : int -> int
		f(x) == x * 2;
		'
		ifError: [:msg | self fail].
	self assert: {'bar' -> '1'. 'buzz' -> '"2"'} asSortedCollection equals: (vdm stateAt: 'DEFAULT') asSortedCollection.
	vdm stateAt: 'DEFAULT' put: {'bar' -> '3'. 'buzz' -> '"456"'}.
	self assert: {'bar' -> '3'. 'buzz' -> '"456"'} asSortedCollection equals: (vdm stateAt: 'DEFAULT') asSortedCollection! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/14/2012 15:11'!
testStateAtPutModule1
	vdm specification: '
module A
definitions
	functions
		f : int -> int
		f(x) == x * 2;
end A		' ifError: [ :msg | self fail].
	self assert: #() equals: (vdm stateAt: 'A').
	vdm stateAt: 'A' put: Array new.
	self assert: #() equals: (vdm stateAt: 'A').! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/14/2012 15:12'!
testStateAtPutModule2
	vdm
		specification: '
module A
definitions
	state foo of
		bar : int
	init
		b == b = mk_foo(1)
	end
	functions
		f : int -> int
		f(x) == x * 2;
end A'
		ifError: [:msg | self fail].
	self
		assert: {'bar' -> '1'}
		equals: (vdm stateAt: 'A').
	vdm stateAt: 'A' put: {'bar' -> '2'}.
	self
		assert: {'bar' -> '2'}
		equals: (vdm stateAt: 'A')! !

!SIVDMTest methodsFor: 'testing' stamp: 'tomooda 11/14/2012 15:37'!
testStateAtPutModule3
	vdm
		specification: '
module A
definitions
	state foo of
		bar : int
		buzz : seq of char
	inv
		mk_foo(bar, buzz) == bar = len buzz
	init
		b == b = mk_foo(1, "2")
	end
	functions
		f : int -> int
		f(x) == x * 2;
end A'
		ifError: [:msg | self fail].
	self assert: {'bar' -> '1'. 'buzz' -> '"2"'} asSortedCollection equals: (vdm stateAt: 'A') asSortedCollection.
	vdm stateAt: 'A' put: {'bar' -> '3'. 'buzz' -> '"456"'}.
	self assert: {'bar' -> '3'. 'buzz' -> '"456"'} asSortedCollection equals: (vdm stateAt: 'A') asSortedCollection! !

TestCase subclass: #SIVDMTokenValueTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-VDM-Test'!

!SIVDMTokenValueTest methodsFor: 'testing' stamp: 'TO 7/25/2012 17:50'!
testEquals
	self assert: (SIVDMTokenValue with: 'freq')
			= (SIVDMTokenValue with: 'freq').
	self deny: (SIVDMTokenValue with: 'freq')
			= (SIVDMTokenValue with: 'frq').
	self deny: (SIVDMTokenValue with: 'freq')
			= (SIVDMTokenValue with: true)! !

!SIVDMTokenValueTest methodsFor: 'testing' stamp: 'TO 7/25/2012 17:51'!
testHash
	self assert: (SIVDMTokenValue with: 'freq') hash equals: (SIVDMTokenValue with: 'freq') hash! !

!SIVDMTokenValueTest methodsFor: 'testing' stamp: 'TO 7/25/2012 17:53'!
testPrintString
	self assert: 'mk_token(''fure'')' equals: (SIVDMTokenValue with: 'fure') printString! !

!SIVDMTokenValueTest methodsFor: 'testing' stamp: 'TO 7/25/2012 20:15'!
testStoreString
	| data |
	data := SIVDMTokenValue with: 'fure'.
	self assert: data equals: (Compiler evaluate: (data) storeString)! !

!SIVDMTokenValueTest methodsFor: 'testing' stamp: 'TO 7/25/2012 17:50'!
testValue
	self assert: 'fure' equals: (SIVDMTokenValue with: 'fure') value! !

Object subclass: #SIVDMTokenValue
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-VDM-Process'!

!SIVDMTokenValue class methodsFor: 'instance creation' stamp: 'TO 7/25/2012 10:15'!
with: anObject 
	^ self new setValue: anObject;
		 yourself! !

!SIVDMTokenValue methodsFor: 'comparing' stamp: 'TO 7/25/2012 15:33'!
= anObject
	^ anObject class == self class and: [anObject value = self value]! !

!SIVDMTokenValue methodsFor: 'comparing' stamp: 'TO 7/25/2012 15:33'!
hash
	^ self class hash bitXor: value hash! !

!SIVDMTokenValue methodsFor: 'printing' stamp: 'TO 7/25/2012 10:16'!
printOn: aStream
	aStream nextPutAll: 'mk_token('.
	value printOn: aStream.
	aStream nextPut: $)! !

!SIVDMTokenValue methodsFor: 'private' stamp: 'TO 7/25/2012 10:16'!
setValue: anObject
	value := anObject! !

!SIVDMTokenValue methodsFor: 'printing' stamp: 'TO 7/25/2012 10:17'!
storeOn: aStream 
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' with: ('.
	value storeOn: aStream.
	aStream nextPut: $)! !

!SIVDMTokenValue methodsFor: 'accessing' stamp: 'TO 7/25/2012 10:15'!
value
	^ value! !

SIValueParser subclass: #SIVDMValueParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SomethingIt-VDM-Process'!

!SIVDMValueParser methodsFor: 'defaults' stamp: 'tomooda 11/1/2012 11:05'!
defaultAlgebraicDataClass
	^ SIVDMRecordValue! !

!SIVDMValueParser methodsFor: 'defaults' stamp: 'tomooda 11/1/2012 10:54'!
defaultClassMap
	^ super defaultClassMap
		at: #Map
		put: [:dict | Dictionary withAll: dict];
		
		at: #Quote
		put: [:string | string asSymbol];
		
		at: #Token
		put: [:value | SIVDMTokenValue with: value];
		
		at: #Record
		put: [:constructor :args | self constructAlgebraicData: constructor args: args];
		 yourself! !

!SIVDMValueParser methodsFor: 'defaults' stamp: 'TomohiroOda 7/20/2012 10:24'!
defaultEscapeMap
	| readHex readOctal |
	readHex := [ :stream | 
	| code |
	code := 0.
	[ 
	stream atEnd not
		and: [ 
			| index |
			index := #($0 $1 $2 $3 $4 $5 $6 $7 $8 $9 $a $b $c $d $e $f) indexOf: stream peek asLowercase.
			index > 0
				and: [ 
					code := code * 16 + index - 1.
					stream next notNil ] ] ] whileTrue.
	Character value: code ].
	readOctal := [ :stream | 
	| code |
	code := 0.
	[ 
	stream atEnd not
		and: [ 
			| index |
			index := #($0 $1 $2 $3 $4 $5 $6 $7) indexOf: stream peek.
			index > 0
				and: [ 
					code := code * 8 + index - 1.
					stream next notNil ] ] ] whileTrue.
	Character value: code ].
	^ (Dictionary new)
		at: $a put: (Character value: 7);
		at: $b put: (Character value: 8);
		at: $f put: (Character value: 12);
		at: $n put: Character lf;
		at: $r put: Character cr;
		at: $t put: Character tab;
		at: $v put: (Character value: 11);
		at: $e put: (Character value: 27);
		at: $' put: $';
		at: $" put: $";
		at: $\ put: $\;
		at: $x put: readHex;
		at: $c
			put: [ :stream | 
					| code |
					code := stream next asLowercase.
					(code between: $a and: $z)
						ifTrue: [ Character value: code - $a + 1 ]
						ifFalse: [ self error: 'Invalid control format in a String literal' ] ];
		at: $u put: readHex;
		at: $0 put: readOctal;
		at: $1 put: readOctal;
		at: $2 put: readOctal;
		at: $3 put: readOctal;
		at: $4 put: readOctal;
		at: $5 put: readOctal;
		at: $6 put: readOctal;
		at: $7 put: readOctal;
		yourself! !

!SIVDMValueParser methodsFor: 'parsing' stamp: 'tomooda 11/13/2012 14:03'!
parseErrorMessage: aStream
	| message |
	message := String new writeStream.
	[ 
	| char |
	aStream atEnd
		ifTrue: [ ^ message contents ].
	char := aStream next.
	char = Character lf
		ifTrue: [ char := Character cr ].
	message nextPut: char.
	(char = Character cr and: [ aStream peek = $> ])
		ifTrue: [ ^ message contents ] ] repeat! !

!SIVDMValueParser methodsFor: 'parsing' stamp: 'TO 7/27/2012 11:00'!
parseIdentifierExpression: aReadStream 
	| constructor args |
	constructor := self parseIdentifier: aReadStream.
	constructor = 'true'
		ifTrue: [^ true].
	constructor = 'false'
		ifTrue: [^ false].
	aReadStream peek = $(
		ifFalse: [^ self error: 'Invalid function expression. Missing (.'].
	aReadStream next.
	self skipSeparator: aReadStream.
	args := aReadStream peek = $)
				ifTrue: [Array new]
				ifFalse: [self parseExpressionList: aReadStream separatedBy: ','].
	self skipSeparator: aReadStream.
	aReadStream next = $) ifFalse: [^self error: 'Invalid function expression. Missing ).'].
	constructor = 'mk_token'
		ifTrue: [^ (classMap at: #Token)
				value: args first].
	constructor = 'mk_'
		ifTrue: [^ (classMap at: #Tuple)
				value: args].
	^ (classMap at: #Record)
		value: constructor
		value: args! !

!SIVDMValueParser methodsFor: 'parsing' stamp: 'TO 9/20/2012 11:22'!
parseParen: aReadStream
	| value |
	aReadStream next = $(
		ifFalse: [ ^ self error: 'Missing (' ].
	aReadStream peek = $)
		ifTrue: [ aReadStream next. ^nil].
	value := self parseStream: aReadStream.
	aReadStream next = $)
		ifFalse: [ ^ self error: 'Missing )' ].
	^ value! !

!SIVDMValueParser methodsFor: 'parsing' stamp: 'TO 7/25/2012 10:12'!
parseQuote: aReadStream
	| value |
	aReadStream next = $<
		ifFalse: [ ^ self error: 'Missing <' ].
	value := String new writeStream.
	[aReadStream peek ~= $>] whileTrue: [
		value nextPut: aReadStream next].
	aReadStream next = $>
		ifFalse: [ ^ self error: 'Missing >' ].
	^ value contents asSymbol! !

!SIVDMValueParser methodsFor: 'parsing' stamp: 'TO 7/25/2012 15:25'!
parseSet: aReadStream
	| maps expression char |
	aReadStream next = ${
		ifFalse: [ ^ self error: 'Invalid expression. Missing {' ].
	aReadStream peek = $}
		ifTrue: [ 
			aReadStream next.
			^ (classMap at: #Set) value: Array new ].
	expression := self parseStream: aReadStream.
	char := aReadStream peek.
	char = $}
		ifTrue: [ 
			aReadStream next.
			^ (classMap at: #Set) value: (Array with: expression) ].
	char = $,
		ifTrue: [ 
			aReadStream next.
			self skipSeparator: aReadStream.
			^ (classMap at: #Set) value: ((self parseExpressionList: aReadStream separatedBy: ',') copyWith: expression) ].
	self skipSeparator: aReadStream.
	(self parse: aReadStream accept: '|=>')
		ifFalse: [ ^ self error: 'Invalid map expression. Missing |=> ' ].
	maps := Dictionary new.
	maps at: expression put: (self parseStream: aReadStream).
	char := aReadStream peek.
	char = $}
		ifTrue: [ 
			aReadStream next.
			^ (classMap at: #Map) value: maps ].
	(self parse: aReadStream accept: ',')
		ifFalse: [ ^ self error: 'Invalid map expression. Missing , ' ].
	[ aReadStream atEnd not ]
		whileTrue: [ 
			expression := self parseStream: aReadStream.
			self skipSeparator: aReadStream.
			(self parse: aReadStream accept: '|=>')
				ifFalse: [ ^ self error: 'Invalid map expression. Missing |=> ' ].
			maps at: expression put: (self parseStream: aReadStream).
			char := aReadStream peek.
			char = $}
				ifTrue: [ 
					aReadStream next.
					^ (classMap at: #Map) value: maps ].
			self skipSeparator: aReadStream.
			(self parse: aReadStream accept: ',')
				ifFalse: [ ^ self error: 'Invalid map expression. Missing , ' ] ].
	^ self error: 'Unexpected end of stream. Missing }'! !

!SIVDMValueParser methodsFor: 'parsing' stamp: 'TO 9/20/2012 11:27'!
parseStream: aReadStream ifError: errorBlock
	| char |
	self skipSeparator: aReadStream.
	char := aReadStream peek.
	(char isDigit
			or: [char = $-])
		ifTrue: [^ self parseNumber: aReadStream].
	(self isIdentifierChar: char)
		ifTrue: [^ self parseIdentifierExpression: aReadStream].
	char = $(
		ifTrue: [^ self parseParen: aReadStream].
	char = $[
		ifTrue: [^ self parseList: aReadStream].
	char = ${
		ifTrue: [^ self parseSet: aReadStream].
	char = $<
		ifTrue: [^ self parseQuote: aReadStream].
	char = $"
		ifTrue: [^ self parseString: aReadStream].
	char = $'
		ifTrue: [^ self parseCharacter: aReadStream].
	^ errorBlock value: 'Unknown expression'! !

!SIVDMValueParser methodsFor: 'private' stamp: 'tomooda 11/14/2012 15:18'!
scanTuple: aPositionableStream plainElementsDo: aBlock ifError: errorBlock
	(aPositionableStream next: 4) = 'mk_(' ifFalse: [ ^errorBlock value: 'Not a tuple'].
	[ | start end |
	aPositionableStream skipSeparators.
	start := aPositionableStream position.
	self parseStream: aPositionableStream.
	end := aPositionableStream position.
	aPositionableStream position: start.
	aBlock value: (aPositionableStream next: end - start).
	aPositionableStream next = $,] whileTrue! !
